<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class BairroController extends TeknisaCrud {
    protected $dataSourceName = 'bairro';
    protected $parameterBagColumns = array('P_NRORG', 'P_NRORGPADRAO');
    
    public function __construct ($crudService, $parameterBag){

        parent::__construct($crudService, $parameterBag);
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            if (array_key_exists('CDBAIRRO', $row)) {
                if ($row['__is_new']) {
                    $row['CDBAIRRO'] = NovoCodigo::geraCodigo($row['NRORG'], "BAIRRO", 1, 10, false, true);
                }
            } else {
                $row['CDBAIRRO'] = NovoCodigo::geraCodigo($row['NRORG'], "BAIRRO", 1, 10, false, true);
            }
            $row['CDREGIAOMUNI'] = ""; 
            $row['VRTXENTREGA']   = "";
            $row['QTHORAENTREGA'] = "";
            
            parent::save($request, $response);
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
?>