<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Teknisa\Model\Util\NovoCodigo;


class OrgTrabController extends TeknisaCrud {
    
    protected $dataSourceNameGet = 'getOperador';
    protected $dataSourceNameSave = 'getOperadorFull';
    protected $dataSourceNameOrg = 'getRelatedOrganizations';
    protected $parameterBagColumns = array('P_NRORG', 'P_CRM_NRORGTRAB', 'P_CDOPERADOR');
    
    public function __construct($crudService, $parameterBag, $entityManager, $newCode, $environment, $util, $CRMParameters, $orgTrabService) {
            
        $this->entityManager              = $entityManager;
        $this->connection                 = $entityManager->getConnection();
        $this->newCode                    = $newCode;
        $this->environment                = $environment;
        $this->crmParameters              = $CRMParameters;
        $this->util                       = $util;
        $this->orgTrabService             = $orgTrabService;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function getCurrentOrgOper(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameGet;
        parent::find($request, $response);
    }
    
    public function getRelatedOrganizations(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameOrg;
        parent::find($request, $response);
    }
    
    public function getNrOrgTrabalhoAtual(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameGet;
        parent::find($request, $response);
    }

    public function saveConfiguration(DTO\Request\Row $rows, DTO\Response $response) {
        try {
            $this->dataSourceName = $this->dataSourceNameSave;
            $row = $rows->getRow();
            
            if($row['CRM_NRORGTRAB'] != $this->crmParameters->getNrorgTrabalho()) {
                $this->crmParameters->changeSessionParam('CRM_NRORGTRABALHO', $row['CRM_NRORGTRAB']);
            }
            
            parent::save($rows, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    protected function populateParameterBag(FilterCriteria $filterCriteria) {
        
        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
    }
}