<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Row;

class PerfilAtividadeController extends TeknisaCrud {
    
    protected $dataSourceName = 'crm_perfilatividade';
    protected $environment;
    protected $newCode;
    
    public function __construct ($crudService, $parameterBag, $newCode, $environment)
    {
        $this->newCode                    = $newCode;
        $this->environment = $environment;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function save(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            if (array_key_exists('NRSEQPERFATIV', $row)) {
                if ($row['__is_new']) {
                    $row["NRORG"] = $this->environment->getNrOrgTrab();
                    $row['NRSEQPERFATIV'] = $this->newCode->getCodeByTableName("CRM_PERFILATIV", $row["NRORG"]);
                }
            } else {
                $row['NRSEQPERFATIV'] = $this->newCode->getCodeByTableName("CRM_PERFILATIV", $row["NRORG"]);
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
    