<?php
namespace Teknisa\CRM\Util;

class ExcelUtils
{
	private $xls;
	private $columnMaxBound;
	private $rowMaxBound;

	public function __construct($xlsFilePath) 
	{
        $xls       = \PHPExcel_IOFactory::createReaderForFile($xlsFilePath);
		$xlsReader = $xls->load($xlsFilePath);
		$this->xls = $xlsReader->getActiveSheet();

		$this->columnMaxBound = \PHPExcel_Cell::columnIndexFromString($this->xls->getHighestColumn());
		$this->rowMaxBound    = $this->xls->getHighestRow();
        $cell = $this->xls->getCellByColumnAndRow(1, $this->rowMaxBound);
	}

	public function buildDataIntoJson()
	{
		return $this->getData();
	}

	private function getData() 
	{
		$headers = $this->getHeaders();
		$data    = array();
        // A primeira linha a ser percorrida deve ser a primeira contendo dados (a linha 1 contem os cabecalhos dos dados).
        for ($i = 2; $i <= $this->rowMaxBound; $i++) {
            foreach ($headers as $key => $value) {
				$cell = $this->xls->getCellByColumnAndRow($key, $i);
                $value = strtoupper(\Teknisa\CRM\Util\Util::removeCaracteresInvalidos($value));
				$data[$i][$value] = $cell->getFormattedValue();
            }
        }
		return $data;
	}

	private function getHeaders() 
	{
		$headers = array();
		for ($i = 0; $i < $this->columnMaxBound; $i++) {
			$cell = $this->xls->getCellByColumnAndRow($i, 1);
			$headers[] = $cell->getValue();
		}

		return $headers;
	}

}