var ZeedhiDirectives = angular.module("ZeedhiDirectives");

ZeedhiDirectives.directive('zhFindLine', function(templateManager, ZhKeyboardService, ShortcutDeveloperService){
	return {
		link: function($scope, $element, $attributes, $controller){
			var toFindLine = false;
			var ENTER_KEY_CODE = 13;
			var ESC_KEY_CODE = 27;
			var WIDGET_NAME = "widgetOfFindLine";

			function hideFindLine(){
				toFindLine = false;
				templateManager.updateTemplate();
			}

			$scope.isToFindLine = function (){
				return toFindLine && !$scope.inFormMode();
			};

			$scope.findLine = function(args){
				var key = args.e.keyCode;
				var line = $scope.widget.getField('findLine').value();
				if(line && (key < 37 || key > 40)){
					line = line - 1;
					$scope.currentEditor.gotoLine(line, 0);
					$scope.currentEditor.selection.moveTo(line, 0);
					$scope.currentEditor.centerSelection();
				}
				if(key == ENTER_KEY_CODE || key == ESC_KEY_CODE){
					hideFindLine();
				}
			};
			
			function changeToFindLineText(event, key){
				toFindLine = $scope.inFormMode() ? false : !toFindLine;
				return false;
			}
			ZhKeyboardService.bind('mod+g', changeToFindLineText);
			$scope.changeToFindLineText = changeToFindLineText;

			$scope.$watch(
				function(){
					return $scope.isToFindLine();
				}, function(){
					if(toFindLine){
						$scope.DevToolsCtrl.openShortcutWidget(WIDGET_NAME);
					}
				}
			);

			function createFindLineWidget(){
				var FIELDS_CONFIG = {
					findLine: {
						class: "12 zh-find",
						template: "field/number.html",
						placeholder: '00',
						focused: true,
						events : [{
						 	"name":"FieldOnKeyup",
						 	"code": "DevToolsController.findLine(args);",
						 	"id": (+new Date())
						}]
					}
				};
				ShortcutDeveloperService.createWidgetAndContainer(WIDGET_NAME, FIELDS_CONFIG, hideFindLine);
			}
			createFindLineWidget();
		}
	};
});